#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "dllist.h"

Node *insert(Node *lista_ptr, char nome[20], int idd) {
	int aux1;
	Node *new;

	new=(Node *)malloc(sizeof(Node));
	strcpy(new->nome,nome);
	new->idade=idd;

	if (lista_ptr==NULL) {
		new->right=NULL;
		new->left=NULL;
	}
	else {
		lista_ptr=search(lista_ptr,nome,&aux1);

		if (strcmp(nome, lista_ptr->nome)<0) {
			// Insere esq
			new->right=lista_ptr;
			new->left=lista_ptr->left;
			lista_ptr->left=new;
			if (new->left != NULL) 
				new->left->right=new;
		}
		else {
			// Insere dir
			new->left=lista_ptr;
                        new->right=lista_ptr->right;
                        lista_ptr->right=new;
                        if (new->right != NULL) 
                                new->right->left=new;

		}

	}
	return new;
}

Node *search(Node *lista_ptr, char nome[20], int *idd_ptr) {
	int compara;

	if (lista_ptr==NULL) {
		*idd_ptr=-1;
	}
	else {
		compara = strcmp(nome,lista_ptr->nome);
		if (compara==0) {
			*idd_ptr=lista_ptr->idade;
		}
		else if (compara > 0) {
			// Procurar a direita
			while ((lista_ptr->right != NULL)&&(strcmp(nome,lista_ptr->right->nome)>0)) {
				lista_ptr=lista_ptr->right;
			}
			if ((lista_ptr->right != NULL) && (strcmp(nome,lista_ptr->right->nome)==0)) {
				lista_ptr=lista_ptr->right;
				*idd_ptr=lista_ptr->idade;
			}
			else {
				*idd_ptr=-1;
			}
		}
		else {
			// Procurar a esquerda
                        while ((lista_ptr->left != NULL)&&(strcmp(nome,lista_ptr->left->nome)<0)) {
                                lista_ptr=lista_ptr->left;
                        }
                        if ((lista_ptr->left != NULL) && (strcmp(nome,lista_ptr->left->nome)==0)) {
                                lista_ptr=lista_ptr->left;
                                *idd_ptr=lista_ptr->idade;
                        }
                        else {
                                *idd_ptr=-1;
                        }
		}

	}

	return lista_ptr;
}
